package controller

import (
	"math"
	"strconv"

	"gitlab.com/mbugroup/lti-api.git/internal/modules/master/kandangs/dto"
	service "gitlab.com/mbugroup/lti-api.git/internal/modules/master/kandangs/services"
	validation "gitlab.com/mbugroup/lti-api.git/internal/modules/master/kandangs/validations"
	"gitlab.com/mbugroup/lti-api.git/internal/response"

	"github.com/gofiber/fiber/v2"
)

type KandangController struct {
	KandangService service.KandangService
}

func NewKandangController(kandangService service.KandangService) *KandangController {
	return &KandangController{
		KandangService: kandangService,
	}
}

func (u *KandangController) GetAll(c *fiber.Ctx) error {
	query := &validation.Query{
		Page:       c.QueryInt("page", 1),
		Limit:      c.QueryInt("limit", 10),
		Search:     c.Query("search", ""),
		LocationId: c.QueryInt("location_id", 0),
		PicId:      c.QueryInt("pic_id", 0),
	}

	if query.Page < 1 || query.Limit < 1 {
		return fiber.NewError(fiber.StatusBadRequest, "page and limit must be greater than 0")
	}

	result, totalResults, err := u.KandangService.GetAll(c, query)
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.SuccessWithPaginate[dto.KandangListDTO]{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Get all kandangs successfully",
			Meta: response.Meta{
				Page:         query.Page,
				Limit:        query.Limit,
				TotalPages:   int64(math.Ceil(float64(totalResults) / float64(query.Limit))),
				TotalResults: totalResults,
			},
			Data: dto.ToKandangListDTOs(result),
		})
}

func (u *KandangController) GetOne(c *fiber.Ctx) error {
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	result, err := u.KandangService.GetOne(c, uint(id))
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Success{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Get kandang successfully",
			Data:    dto.ToKandangListDTO(*result),
		})
}

func (u *KandangController) CreateOne(c *fiber.Ctx) error {
	req := new(validation.Create)

	if err := c.BodyParser(req); err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid request body")
	}

	result, err := u.KandangService.CreateOne(c, req)
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusCreated).
		JSON(response.Success{
			Code:    fiber.StatusCreated,
			Status:  "success",
			Message: "Create kandang successfully",
			Data:    dto.ToKandangListDTO(*result),
		})
}

func (u *KandangController) UpdateOne(c *fiber.Ctx) error {
	req := new(validation.Update)
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	if err := c.BodyParser(req); err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid request body")
	}

	result, err := u.KandangService.UpdateOne(c, req, uint(id))
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Success{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Update kandang successfully",
			Data:    dto.ToKandangListDTO(*result),
		})
}

func (u *KandangController) DeleteOne(c *fiber.Ctx) error {
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	if err := u.KandangService.DeleteOne(c, uint(id)); err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Common{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Delete kandang successfully",
		})
}
